/* ᠭ ணࠬ .   .ࠫ, "設 䨪
    ᮭ ", ., 1991, . **163.
   좮 .. - ॢ  ᪨ .

   This program text has been copied from:
   L. Ammeraal, Computer Graphics for the IBM PC  (page 117),
   published by John Wiley, Chichester, 1987.
*/

/* DIGFUN.C: Functions used in DIG.C, in alphabetical order. */
/*           See also DIGH.C and GRPACK.C.                   */
/*            ⮬ 㫥 ᮡ࠭  䠢⭮ 浪      */
/*           㭪樨, ᯮ㥬  ணࠬ DIG.C         */
/*           . ⠪ 㫨 DIG.H  GRPACK.C               */

#include "stdio.h"
#include "math.h"
#define PI 3.14159265358979
#define PIDOUBLE 6.28318530717959
#define MAX 4000
extern int Xcur, Ycur, Xold, Yold, X__max, Y__max, colorgr,
  stsize, drawmode, Xmin1, Xmax1, Ymin1, Ymax1,
  Xb, Yb, Xk, Yk, keepvector, pendown;
extern float horfact, vertfact;
extern char workstate, fil[];

static int Ybottext, displaymax,
    XI=-1, YI, XE, YE,
    vdefined, Xprev=-1, Yprev, XXold=-1, YYold,
    Xend1, Yend1, Xend2, Yend2, n, marksvisible=1;

static char str[80];
static float
      xxi, yyi, xxe, yye, xx1, yy1, dx,  dy, r, phi0, phi1,

     /* These variables obtain their values in 'geometrics'; */
     /* they are used in 'arc', 'defdirection', 'lsegment'   */
     /* ⨬ ६ 祭 ᢠ  㭪樨     */
     /* 'geometrics'   ᯮ  㭪           */
     /* 'arc', 'defdirection', 'lsegment'                    */

      xmin, xmax, ymin, ymax,
      un=1.0, phi=1000.0;

double fx(), fy();

struct SET { int XX, YY;} set[MAX+1];
		/*  MAX+1 to accommodate sentinel            */
		/*    MAX+1 ࠧ頥 "ࠦ"     */

addset(X1, Y1) int X1, Y1;
		/* Add new point to set (SA)                 */
		/*   窨   (SA)      */
{ struct SET *p;
  int nn, n0, X0, Y0, i;
  if (n == MAX)    /* message("Set full") */
		{ message(" "); return; }
  nn = find(X1, Y1);
  if (nn == n)
  { X0=Xprev; Y0=Yprev;
    if (X0 == X1 && Y0 == Y1) { X0=XXold; Y0=YYold; }
    n0 = find(X0, Y0);
    if (n0 == n) p = set+n; else
    { for (i=n-1; i>n0; i--) set[i+1]=set[i];
      p = set+n0+1;
    }
    p->XX = X1; p->YY = Y1; n++;
    if (marksvisible) mark(X1, Y1);
  }
  XXold=Xprev; YYold=Yprev;
  Xprev=X1; Yprev=Y1;
}

static double angle(xC, yC, x, y) double xC, yC, x, y;

     /* angle between {(xC, yC), (x, y)} and positive x-axis */
     /* 㣮  १ {(xC, yC), (x, y)}   x      */

{ float alpha;
  if (fabs(x - xC) < .0005) return ((y > yC ? .5 : -.5) * PI);
  alpha = atan((y - yC)/(x - xC));
  return (x > xC ? alpha : alpha + PI);
}

arc(sign) int sign;
		   /* Draw arc (C+, C-)                      */
		   /* 稢 㣨   (C+, C-) */

{ float delta, phi, phideg, phi_0, theta;
  int X, Y, n, i, Xold=-1, Yold=-1;

    /*  Draw circle arc, centre I(XI, YI),                   */
    /*              first point E(XE, YE),                   */
    /*  endpoint on CP, where P(Xcur, Ycur), or specified    */
    /*  by angle phi. sign (sense of rotation):              */
    /*  1 = counter clockwise,  -1 = clockwise               */
    /*  If sign = 0, a full circle is drawn.                 */

    /*  㣠 㦭  業஬  窥 I(XI, YI),         */
    /*               砫쭮 窮  E(XE, YE),         */
    /*  筠 窠 㤥 ᯮ  אַ CP,     */
    /*   P(Xcur, Ycur),   אַ  㣫 phi.      */
    /*  ࠬ  sign  ।  ࠢ  㣨:       */
    /*  sign =  1 : ⨢ ᮢ ५,                  */
    /*  sign = -1 :  ᮢ ५,                      */
    /*  sign =  0 :  㦭.                       */

  if (!vdefined)  /* message("Vector?") */
		  { message("?"); return; }
  geometrics(); phi_0=phi0; phi=phi1-phi0;
  if (sign == 0)
  { if (xxi-r < xmin || xxi+r > xmax ||
			yyi-r < ymin || yyi+r > ymax)
  /* message("Outside screen") */
     message(" ࠭    "); else circle(xxi, yyi, r);
     return;
  }
  if (XE==Xcur && YE==Ycur)
  { if /* "Angle:" */ (enquire(" : ", str)==0)
					{ invalid(); return; }
    sscanf(str, "%f", &phideg);
    phi = PI*phideg/180.0;
  }
  n = (int) (80.0 * r * phi);         /* 80 points per inch! */
				      /* 80 祪   !  */
  n = abs(n);
  delta = sign * phi/n;
  for (i=1; i<=n; i++)
  { theta = phi_0 + i * delta;
    X = IX(xxi+r*cos(theta)); Y = IY(yyi+r*sin(theta));
    if ((X != Xold || Y != Yold) && (X > Xmin1 &&
	 X < Xmax1 && Y > Ymin1 && Y < Ymax1)) dot(X, Y);
    Xold=X; Yold=Y;
  }
  addset(Xold, Yold);
}

arrow()
			/* Erase/draw arrow (VA)             */
			/* ࠭/稢 ५     */

{ float a, b, xdif, ydif, tx, ty;
  a=dx/r; b=dy/r;
  xdif=xxe-0.125*a; ydif=yye-0.125*b;
  tx=0.05*b; ty=0.05*a;
  clipdraw(xdif+tx, ydif-ty, xxe, yye);
  clipdraw(xdif-tx, ydif+ty, xxe, yye);
}

blcopy(ch1) char ch1;
				    /* Copy a block (BC, BM) */
				    /* ஢      */

{ int Blength, Bwidth, X, Y, XX1, YY1, invicalled=0;
  cur();
  if (marksvisible) { inviset(); invicalled=1; }
  if (ch1=='M') delpinblock();
      /* Remove all points inside old block from set         */
      /*     祪  ண   */
  Blength=Xk-Xb; Bwidth=Yk-Yb;
  for (X=Xb; X<=Xk; X++)
  for (Y=Yb; Y<=Yk; Y++)
  if (pixlit(X, Y))
  { XX1=Xcur+X-Xb; YY1=Ycur+Y-Yb;
    if (XX1<=Xmax1 && YY1<=Ymax1) dot(XX1, YY1);
    if (ch1=='M')
    { drawmode=-1; dot(X, Y); drawmode=0;
    }
  }
  Xb=Xcur; Yb=Ycur; Xk=Xcur+Blength; Yk=Ycur+Bwidth;
  if (Xk>Xmax1) Xk=Xmax1;
  if (Yk>Ymax1) Yk=Ymax1;
  cur();
  addset(Xb, Yb); addset(Xk, Yk);
  if (invicalled) inviset();
}

bldelete()
				      /* Delete a block (BD) */
				      /*        */

{ int X, Y;
  delpinblock();
  drawmode=-1;                          /* delete block      */
                                        /*      */
  cur();
  for (X=Xb; X<=Xk; X++)
  for (Y=Yb; Y<=Yk; Y++) dot(X, Y);
  drawmode=0; cur();
}

blread()                                /* Read a block (BR) */
					/* 뢠   */

{ FILE *fp; int Blength, Bwidth, j, X, Y, buflen;
  unsigned char bitbuf[100], *p;
  if (enquire("File:  ", str)==0) return;
  fp=fopen(str, "rb");
  if (fp==NULL)  /* message("Unknown file") */
  {                message(" 䠩"); return;
  }
  cur();
  fread((char *)&Blength, 1, sizeof(int), fp);
  fread((char *)&Bwidth, 1, sizeof(int), fp);
  Xb=Xcur; Yb=Ycur; Xk=Xb+Blength; Yk=Yb+Bwidth;
  buflen=(Blength>>3)+1;
  for (Y=Yb; Y<=Yk; Y++)
  { fread(bitbuf, 1, buflen, fp);
    j=0; p=bitbuf;
    if (Y<=Ymax1)
    for (X=Xb; X<=Xk; X++)
    { if (*p & 0x80 && X<=Xmax1) dot(X, Y);
      *p <<= 1;
      if (++j == 8) { p++; j=0; }
    }
  }
  if (Xk>Xmax1) Xk=Xmax1;
  if (Yk>Ymax1) Yk=Ymax1;
  addset(Xb, Yb); addset(Xk, Yk);
  fclose(fp); cur();
}

blwrite()                              /* Write a block (BW) */
				       /*         */

{ FILE *fp; int Blength, Bwidth, i, j, X, Y, buflen;
  unsigned char bitbuf[100], *p;
  if /* enquire ("File: ") */
       (enquire (": ", str)==0) return;
  delpinblock();
  cur(); fp=fopen(str, "wb");
  Blength=Xk-Xb; Bwidth=Yk-Yb; buflen=(Blength>>3)+1;
  fwrite((char *)&Blength, 1, sizeof(int), fp);
  fwrite((char *)&Bwidth, 1, sizeof(int), fp);
  for (Y=Yb; Y<=Yk; Y++)
  { for (i=0; i<buflen; i++) bitbuf[i]=0;
    j=0; p=bitbuf;
    for (X=Xb; X<=Xk; X++)
    { *p <<= 1;
      if (pixlit(X, Y)) *p |= 1;
      if (++j == 8) { p++; j=0; }
    }
    *p <<= (8-j);
    fwrite(bitbuf, 1, buflen, fp);
  }
  fclose(fp); cur();
}

clearset()                  /* Clear the set of points (SC)  */
			    /* ࠭  祪   */
{ int i;
  struct SET *p;
  if (marksvisible)
  for (i=0; i<n; i++)
  { p = set + i; mark(p->XX, p->YY);
  }
  n=0;
}

static int clipcode(x, y) float x, y;

{ return ((x<xmin)<<3) | ((x>xmax)<<2) |
         ((y<ymin)<<1) | ((y>ymax));
}

static clipdraw(x1, y1, x2, y2) float x1, y1, x2, y2;

{ int c1, c2;
  float dx, dy;
  c1=clipcode(x1, y1); c2=clipcode(x2, y2);
  while (c1|c2)
  { if (c1&c2) return;
    dx=x2-x1; dy=y2-y1;
    if (c1)
    { if (c1 & 8) { y1 += dy*(xmin-x1)/dx; x1=xmin; } else
      if (c1 & 4) { y1 += dy*(xmax-x1)/dx; x1=xmax; } else
      if (c1 & 2) { x1 += dx*(ymin-y1)/dy; y1=ymin; } else
      if (c1 & 1) { x1 += dx*(ymax-y1)/dy; y1=ymax; }
      c1=clipcode(x1, y1);
    } else
    { if (c2 & 8) { y2 += dy*(xmin-x2)/dx; x2=xmin; } else
      if (c2 & 4) { y2 += dy*(xmax-x2)/dx; x2=xmax; } else
      if (c2 & 2) { x2 += dx*(ymin-y2)/dy; y2=ymin; } else
      if (c2 & 1) { x2 += dx*(ymax-y2)/dy; y2=ymax; }
      c2=clipcode(x2, y2);
    }
  }
  move(x1, y1); Xend1=Xcur; Yend1=Ycur;    /* to be used in  */
  draw(x2, y2); Xend2=Xcur; Yend2=Ycur;    /* lsegment!      */
  Xend1 = fx(x1); Yend1 = fy(y1);    /* Used in 'lsegment'   */
  Xend2 = fx(x2); Yend2 = fy(y2);
	 /*  ६ ᯮ  㭪樨 'lsegment' */
}

coord()			   /* Display coordinate values      */
			   /* ⮡ࠦ 祭 न */

{ prnum(192, Xcur); prnum(272, Ycur);
}

cur()             	     /* Display/erase cursor         */
			     /* ⮡ࠦ/࠭  */
{ int i, j, dm;
  dm=drawmode; drawmode=0;      /* change color, using  xor  */
			  /*  梥 樥 'xor' */
  for (j=-2; j<=2; j+=4)
  for (i=-4; i<=4; i++) dot(Xcur+i, Ycur+j);
  dot(Xcur-4, Ycur-1); dot(Xcur-3, Ycur-1);
  dot(Xcur+3, Ycur-1); dot(Xcur+4, Ycur-1);
  dot(Xcur-4, Ycur); dot(Xcur-3, Ycur); dot(Xcur+3, Ycur);
  dot(Xcur+4, Ycur);  dot(Xcur, Ycur);
  dot(Xcur-4, Ycur+1); dot(Xcur-3, Ycur+1);
  dot(Xcur+3, Ycur+1); dot(Xcur+4, Ycur+1);
  drawmode=dm;
}

#define ARSIZE 1004

curvefit(closed) int closed;

{ int ninit, nend, i, j, N=15, first=1, nr[ARSIZE], m;
  float xA, xB, xC, xD, yA, yB, yC, yD, x, y,
    a0, a1, a2, a3, b0, b1, b2, b3, t;
  double fx(), fy();
  struct SET *p;
  ninit = find(XI, YI);
		  /* If not found in 'set', 'find' returns n */
		  /* ᫨ 窠     'set',   */
		  /*  㭪 'find' 頥 祭 n */
  nend = find(XE, YE);
  if (nend == n || nend - ninit < 3)
				  { ninit = 0; nend = n - 1; }
  m = nend - ninit;
  if (m < 3)  /* message("Too few points") */
              { message("誮  祪"); return; }
 if (m + 3 > ARSIZE) /* message("Too many points") */
		   { message("誮  祪"); return; }
  for (i=0; i <= m; i++) nr[i] = ninit + i;
  if (closed)
    { nr[++m] = ninit; nr[++m] = ninit+1; nr[++m] = ninit+2; }
  for (i=1; i<m-1; i++)
  { p = set + nr[i-1]; xA = fx(p -> XX); yA = fy(p -> YY);
    p = set + nr[i];   xB = fx(p -> XX); yB = fy(p -> YY);
    p = set + nr[i+1]; xC = fx(p -> XX); yC = fy(p -> YY);
    p = set + nr[i+2]; xD = fx(p -> XX); yD = fy(p -> YY);
    a3=(-xA+3*(xB-xC)+xD)/6.0; b3=(-yA+3*(yB-yC)+yD)/6.0;
    a2=(xA-2*xB+xC)/2.0;       b2=(yA-2*yB+yC)/2.0;
    a1=(xC-xA)/2.0;            b1=(yC-yA)/2.0;
    a0=(xA+4*xB+xC)/6.0;       b0=(yA+4*yB+yC)/6.0;
    for (j=0; j<=N; j++)
    { t=(float)j/(float)N;
      x=((a3*t+a2)*t+a1)*t+a0;
      y=((b3*t+b2)*t+b1)*t+b0;
      if (x > xmin && x < xmax && y > ymin && y < ymax)
      { if (first) { first=0; move(x, y);} else draw(x, y);
      }
    }
  }
}

static dash(x1, y1, x2, y2) float x1, y1, x2, y2;

{ int i, k;
  float xdif=x2-x1, ydif=y2-y1, pitch0=0.3, dx, dy;
  k = 2 * (int)ceil(sqrt(xdif*xdif+ydif*ydif)/pitch0) + 1;
  dx=xdif/k; dy=ydif/k;
  for (i=0; i<k; i+=2)
  { move(x1+i*dx, y1+i*dy); draw(x1+(i+1)*dx, y1+(i+1)*dy);
  }
}

defdirection()			  /* Define direction (DD)   */
				  /* । ࠢ */

{ enquire   /* Enter angle or *: */
	   (" 㣮  *:", str);
  if (sscanf(str, "%f", &phi) > 0) phi=phi*PI/180.0; else
  { if (!vdefined) {  /* message ("Vector?") */
			 message("?"); return; }
    phi=phi0;
  }
}

static delpinblock()
	       /* Delete all points within block from set    */
	       /*     祪   */

{ int i, j, X, Y;
  struct SET *p;
  for (i=0; i<n; i++)
  { p = set+i; X = p->XX; Y=p->YY;
    if (X>=Xb && X<=Xk && Y>=Yb && Y<=Yk)
    if (marksvisible) mark(X, Y);                /* delete   */
    n--;                                         /* 㤠 */
    for (j=i; j<n; j++) set[j]=set[j+1];
    i--;
  }
}

delpset(X1, Y1)              /* Remove a point from set (SD) */
			     /* ᪫祭 窨     */
{ int i, j;
  i=find(X1, Y1);
  if (i==n)  {  /* message("Not in set") */
		   message("  "); return; }
  if (marksvisible) mark(X1, Y1);                /* delete   */
  n--;                                           /* 㤠 */
  for (j=i; j<n; j++) set[j]=set[j+1];
}

dmode(m) int m;          /* Change drawing mode (PP, PN, PA) */
			 /*  ० 祭        */
	 /*  1 = Positive,  -1 = Negative,  0 = Alternate    */
	 /*  1 = 祭,  -1 = ࠭,  0 = ६   */

{ textXY(0, 55, m == 1 ? "P" : m == -1 ? "N" : "A");
  drawmode = m;
}

drawtoP()               /* Draw line segment (L)             */
			/* 稢 १ אַ  */
{ int X, Y;
  if (Xcur==Xprev && Ycur==Yprev)
  { X = XXold; Y = YYold;
  } else
  { X = Xprev; Y = Yprev; addset(Xcur, Ycur);
  }
   if (X<0)  /* message("Previous point?") */
		message("। 窠?");
                   else draw_line(X, Y, Xcur, Ycur);
}

endpoint()
		       /* Define vector endpoint (E)         */
		       /* । 筮 窨  */

{ if (XI == -1) /* message ("Point I?") */
                {  message ("窠 I?"); return; }
  if (Xcur==XI && Ycur==YI) /* message("Zero vector!") */
                  { message("㫥 !"); return; }
  if (vdefined && !keepvector)
		    ievector();       /* delete vector IE   */
				      /* 㤠    */
  XE=Xcur; YE=Ycur; geometrics(); addset(Xcur, Ycur);
  ievector(); vdefined=1; keepvector=0;
}

static int enquire(txt, str) char *txt, *str;

{ char ch, s[2]; int i=0, len;
  len=strlen(txt);
  message(txt); s[1]='\0';
  while (ch=getch(), ch != '\n' && ch != '\r' && ch != ' ')
  { if (ch==8)
    { if (--i<0) i=0;            /* dealing with backspace   */
      continue;                  /* ⨥  ࠭ */
    }
    str[i]=s[0]=ch; textXY((len+i+1)<<3, 0, s); i++;
  }
  str[i]='\0';
  return i;
}

static int find(X, Y) int X, Y;
		 /* Find position of (X, Y) in set           */
		 /* 宦 樨 窨 (X, Y)   */

{ struct SET *p;
  p=set+n;
  p->XX = X; p->YY = Y;            /* sentinel */
				   /* 'ࠦ'  */
  for (p=set; p->XX != X || p->YY != Y; p++);
					  /* empty statement */
					  /* ⮩  */
  return p-set;      /* if found, position (<n), otherwise n */
		     /* ᫨ 窠 ,   <n,   */
		     /*  頥 祭 n        */
}

findset()
	   /* Move current point to nearest point in set (F) */
	/* ७ ⥪饩 窨      */

{ int XP, YP;
  struct SET *p;
  float minim2=1.0e10, x1, y1, dx, dy, sq;
  if (n==0) /* message("Empty set") */
            {  message(" "); return; }
  x1=fx(Xcur); y1=fy(Ycur);
  for (p=set; p<set+n; p++)
  { dx=fx(p->XX)-x1; dy=fy(p->YY)-y1; sq = dx*dx + dy*dy;
    if (sq<minim2) { minim2=sq; XP = p->XX; YP = p->YY; }
  }
  cur(); Xcur=XP; Ycur=YP; cur(); coord();
  XXold=Xprev; YYold=Yprev;
  Xprev=Xcur; Yprev=Ycur;
}

static double fx(X) int X; { return X/horfact; }
static double fy(Y) int Y; { return (Y__max - Y)/vertfact; }

static geometrics()
     /*  Computes the global variables                       */
     /*  ᫥  ६                    */
     /*  xxi, yyi, xxe, yye, xx1, yy1, dx, dy, r, phi0, phi1 */

{ xxi = fx(XI); yyi = fy(YI);
  xxe = fx(XE); yye = fy(YE);
  xx1 = fx(Xcur); yy1 = fy(Ycur);
  dx = xxe - xxi; dy = yye - yyi;
  r = sqrt(dx * dx + dy * dy);
  phi0 = angle(xxi, yyi, xxe, yye);
  phi1 = angle(xxi, yyi, xx1, yy1);
}

hardcopy(code) char code;
			  /* Picture to printer (P0, P1, P2) */
			  /* 뢮 ࠦ  ਭ    */

{ int Xlo, Xhi, Ylo, Yhi;
  if (code == '2') { Xlo=Ylo=0; Xhi=X__max; Yhi=Y__max; }
     else { Xlo=Xmin1; Xhi=Xmax1; Ylo=Ymin1; Yhi=Ymax1; }
  if (code == '0') { Xlo++; Xhi--; Ylo++; Yhi--; }
  printgr(Xlo, Xhi, Ylo, Yhi);
}

icursor(XI, YI) int XI, YI;
				     /* Toggle I-cursor      */
				     /* ४祭  */

{ float xi, yi;
  xi=fx(XI); yi=fy(YI);
  clipdraw(xi-0.1, yi, xi+0.1, yi);
  clipdraw(xi, yi-0.1, xi, yi+0.1);
}

static ievector()

{ draw_line(XI, YI, XE, YE); arrow();
}

invalid()	/* Display error message "Invalid character" */
		/* ⮡ࠦ ᮮ饭  訡           */
{   message (" ᨬ");
}

inviset()   /* Make points in set invisible/visible (SI) */
	    /* ⠭ ०   祪   */

{ struct SET *p;
  for (p=set; p<set+n; p++) { mark(p->XX, p->YY); }
  marksvisible ^= 1;
}

ipoint()    		      /* Initial point of vector (I) */
			      /* 砫쭠 窠      */
{
  if (XI != -1) icursor(XI, YI);      /*  delete cursor at I */
			       /* 㤠   窥 I */
  if (vdefined && !keepvector)        /*   delete vector IE  */
		     ievector();      /* 㤠  IE */
  vdefined=0;
  XI=Xcur; YI=Ycur; icursor(XI, YI);
  addset(Xcur, Ycur);
}

static int load()

{ int i=-1, j;
  short bufar[13];
  unsigned char buf, ncopies;
  FILE *fp;
  fp=fopen(fil, "rb");
  if (fp == NULL) return 0;
  if (fread((char *)bufar, 2, 13, fp) < 13)
                            { fclose(fp); return 0; }
  XI=bufar[0]; YI=bufar[1]; XE=bufar[2]; YE=bufar[3];
  Xcur=bufar[4]; Ycur=bufar[5]; Xb=bufar[6]; Yb=bufar[7];
  Xk=bufar[8]; Yk=bufar[9];
  marksvisible=bufar[10]; n=bufar[11];
  vdefined=bufar[12];
  if (vdefined) geometrics();
			   /* Bug in first version corrected */
	      /*  ᪮஢ 訡  ࢮ ᨨ */
  if (fread((char *)set, sizeof (struct SET), n, fp) < n)
  { fclose(fp); return 0;
  }
  do
  { if (fread(&buf, 1, 1, fp) == 0) { fclose(fp); return 0; }
    poke1(0xB800, ++i, &buf, 1);
    if (buf == 0 || buf == 0xFF)
    { fread(&ncopies, 1, 1, fp);
      if (buf)
      { for (j=0; j<ncopies; j++)
          poke1(0xB800, ++i, &buf, 1);
      } else i+=ncopies;
    }
  } while (i < displaymax);
  fclose(fp); return 1;
}

lseg()
    /* Sketch horizontal or vertical line segment (PD etc.): */
    /* if pendown,                                           */
    /* draw line segment from (Xold, Yold) to (Xcur, Ycur)   */
    /*                                                       */
    /*  ਧ⠫쭮  ⨪쭮 १    */
    /* אַ . ᫨  饭,  稢      */
    /* १  窨 (Xold, Yold)   (Xcur, Ycur)    */

{ static int prevdown,
	/* Was previously a line segment drawn to old point? */
	/*   祭 १ אַ    ?   */
    prevdirection, direction;
  if (pendown)
  { draw_line(Xold, Yold, Xcur, Ycur);
    direction = Xcur < Xold ? -1 :
                Xcur > Xold ?  1 :
                Ycur < Yold ? -2 :
                Ycur > Yold ?  2 : 0;

    /* If prevdirection + direction == 0, and drawmode == 0, */
    /* a line segment just drawn is erased;                  */
    /* beware of an extra call of dot in the point of        */
    /* reversal,  performed in  draw_line.                   */
    /*  ᫮   prevdirection + direction == 0         */
    /*               drawmode == 0                           */
    /* ⮫쪮  祭 १ אַ  㤠.*/
    /* 室 ᮡ  ஦    ⥫ */
    /* 饭     㭪樨  'dot'    窥   ,  */
    /* 믮塞    㭪樨 'draw_line'.                  */

    if (prevdown && drawmode==0 &&
        prevdirection + direction == 0)
        dot(Xold, Yold);
		  /* fourth call of dot in (Xold, Yold)      */
		  /* ⢥⮥ 饭  㭪樨 'dot'     */
		  /*  窥 (Xold, Yold)                    */
  }
  prevdown = pendown; prevdirection = direction;
}

lsegment(code) int code;           /*  :    */
				   /* (VS (0), VD(1), VL(2) */

 /* code 0: drawn segment, 1: dashed segment,  2: long line */
 /*  0 :  १,                               */
 /*  1 : १ 客 ,                        */
 /*  2 : ᯫ譠  ﬠ                    */

{ int XX1, YY1, XX2, YY2;
  if (vdefined)
  { arrow();                          /* delete arrow       */
				      /* 㤠 ५   */
    icursor(XI, YI);                  /* delete cursor at I */
			      /* 㤠   窥 I */
    if (code)
    { draw_line(XI, YI, XE, YE);     /* delete line segment */
				 /* 㤠 १ אַ */
      if (code==1) dash(xxi, yyi, xxe, yye); else
      { float c, s;
        c=10.0*cos(phi0); s=10.0*sin(phi0);
        clipdraw(xxi-c, yyi-s, xxi+c, yyi+s);
	   /* 'clipdraw'computes Xend1, Yend1, Xend2, Yend2 */
	   /*  㭪樨 'clipdraw'  祭     */
	   /* ६  Xend1, Yend1, Xend2, Yend2        */

        XX1=Xend1; YY1=Yend1;
        XX2=Xend2; YY2=Yend2;
		   /* Local copies (XX2, YY2) are needed    */
		   /* for reasons of security               */
		   /*   (XX2, YY2) 室 */
		   /*  窨 ७              */
        addset(XX1, YY1);
        addset(XX2, YY2);
      }
    }
    vdefined=0; XI=-1;
  } else message(" e");      /* message("No vector") */
}

static mark(X, Y) int X, Y;

{ float x, y, dx=0.07, dy=0.07;
  x=fx(X); y=fy(Y);
  clipdraw(x-dx, y-dy, x+dx, y+dy);
  clipdraw(x-dx, y+dy, x+dx, y-dy);
}

message(str) char *str;
		 /* Erase old message and display new one    */
		 /* ࠭ ண ᮮ饭  ⮡ࠦ */
		 /*                                    */

{ textXY(8, 0, "                               ");
  textXY(8, 0, str);
}

newpoint()     /* Find a new point in a given direction (DN) */
	       /* 롮  窨   ࠢ   */

{ float d0, d, cphi, sphi,
        xold=-1000.0, yold, xnew=-1000, ynew;
  int XX, YY;
  if (phi>100.0) /* message("Angle undefined") */
                 {  message("  ।"); return; }
  xold=fx(Xcur); yold=fy(Ycur); cphi=cos(phi); sphi=sin(phi);
  if (find(Xcur, Ycur)==n) addset(Xcur, Ycur);
			     /* add to set if not yet in it  */
			     /*    ,  ᫨  */
			     /* ⮩ 窨         */

  enquire     /* "Length, or *:" */
		("   *:", str);
  if (sscanf(str,"%f", &d0) > 0) d=d0*un; else
  { if (!vdefined)
	     { message("?"); return; }      /* Vector? */
    d = -(xold*yyi+yold*xxe+xxi*yye-
          xxe*yyi-xxi*yold-xold*yye)/
         (cphi*yyi+sphi*xxe-xxi*sphi-yye*cphi);
	  /* Now  (xold+d*cos(phi), yold+d*sin(phi))  is     */
	  /* the point of intersection we are interested in  */
	  /*  窠 (xold+d*cos(phi), yold+d*sin(phi)) */
	  /*  饩  窮 祭    */
  }
  xnew=xold+d*cphi; ynew=yold+d*sphi;
  XX=IX(xnew); YY=IY(ynew);
  if (XX<Xmin1 || XX>Xmax1 || YY<Ymin1 || YY>Ymax1)
    /* message("Outside screen") */
       message(" ࠭"); else
  { cur(); Xcur=XX; Ycur=YY; cur(); coord();
    addset(Xcur, Ycur);
  }
}


penposition(p) int p;
		 /* Display pen position:  1 = down,  0 = up */
		 /* ⮡ࠦ  : 1 - 饭  */
		 /*                             0 -   */
{ int dm;
  dm=drawmode; drawmode=1;
  textXY(0, p ? 27 : 40, " ");  /* clear old pen portion */
                          /* ࠭  ண  */
  textXY(0, p ? 32 : 27, "H");
  textXY(0, p ? 40 : 35, "V");     /* a picture of a pen */
                                   /* ࠦ    */
  draw_line(0, 48, 6, 48);
                    /* the paper on which the pen writes */
                    /* 㬠,  ன       */
  pendown=p; drawmode=dm;
}

prnum(X, num) int X, num;
		       /* Display a number in bottom margin  */
		       /* ⮡ࠦ ᫠   ப */
{ char str[4];
  sprintf(str, "%3d", num); textXY(X, Ybottext, str);
}

save()			     /* Write entire picture to file */
			     /*  ᥩ ⨭  䠩  */
{ int i=-1;
  short bufar[13];
  unsigned char ncopies, buf, newbuf;
  FILE *fp;
  fp=fopen(fil, "wb");
  if (fp==NULL) { invalid(); return; }
  bufar[0]=XI;   bufar[1]=YI;   bufar[2]=XE; bufar[3]=YE;
  bufar[4]=Xcur; bufar[5]=Ycur; bufar[6]=Xb; bufar[7]=Yb;
  bufar[8]=Xk;   bufar[9]=Yk;   bufar[10]=marksvisible;
  bufar[11]=n;   bufar[12]=vdefined;
  fwrite((char *)bufar, 2, 13, fp);
  fwrite((char *)set, sizeof(struct SET), n, fp);
  do
  { peek1(0xB800, ++i, &buf, 1);
    fwrite(&buf, 1, 1, fp);
    if (buf == 0 || buf == 0xFF)
    { ncopies=0;         /* ncopies = number of extra copies */
			 /*       ᫮ ⥫  */
      if (i < displaymax)
      { while (peek1(0xB800, ++i, &newbuf, 1),
          newbuf==buf)
        { ncopies++;
          if (i == displaymax || ncopies == 0xFF) break;
        }
        if (newbuf != buf) i--;
      }
      fwrite(&ncopies, 1, 1, fp);        /* ncopies may be 0 */
			   /* ᫮    ࠢ 0 */
    }
  } while (i < displaymax);
  fclose(fp);
}

static togrmode()
	      /* Switch to graphics mode, called in 'wstate' */
	      /* ४祭  ᪨ ०,           */
	      /* 뢠  㭪樨 'wstate'              */

{ static int load_desired=1;
  initgr();
  displaymax = (colorgr ? 16383 : 32767);
  Xmin1 = 12; Xmax1 = X__max - 4;
  Ymin1 = 22; Ymax1 = Y__max - 14;
  xmin=fx(Xmin1); xmax=fx(Xmax1);
  ymin=fy(Ymax1); ymax=fy(Ymin1);
  drawmode=1;
  if (load_desired)
  { if (!load())
    {                            /* Completely new drawing:  */
				 /* 襭  ⥦  */
      draw_line(Xmin1, Ymin1, Xmax1, Ymin1);
      draw_line(Xmax1, Ymin1, Xmax1, Ymax1);
      draw_line(Xmax1, Ymax1, Xmin1, Ymax1);
      draw_line(Xmin1, Ymax1, Xmin1, Ymin1);
      Xcur=Ycur=30; cur();
    }
  }
                                       /*  "Stepsize:"  */
  Ybottext = Ymax1 +3; textXY(8, Ybottext, " :");
  textXY(160, Ybottext, "X =");
  textXY(240, Ybottext, "Y =");
  coord(); prnum(112, stsize);
  load_desired = colorgr;
}

toseq(code) int code;

{ int i;
  if (n == 0) /* message("Empty set") */
               { message(" "); return; }
  if (abs(code) == 1 && (i = find(Xcur, Ycur)) == n)
  /* message("Use F first") */
  { message(" ᭠砫 F "); return;
  }
  cur();                                /* Delete old cursor */
				 /* ࠭ ண  */
  switch (code)
  { case -2: i = 0; break;
    case  2: i = n-1; break;
    case -1: if (i > 0) i--; break;
    case  1: if (i < n - 1) i++; break;
  }
  Xcur = set[i].XX; Ycur = set[i].YY;
  XXold=Xprev; YYold=Yprev;
  Xprev=Xcur; Yprev=Ycur;
  cur(); return;
}

static totextmode()			 /* Called in wstate */
			   /* 뢠  㭪樨 'wstate' */
{ to_text(); menu('M');
}

unit()			       /* Define unit of length (DU) */
			       /* ।    */
{ int n;
  float dx, dy;
  if (!vdefined)    /* message("No initial point") */
		   { message(" 砫쭮 窨"); return; }
  if (XE==XI && YE==YI) /* message("Zero vector") */
                        { message("㫥 "); return; }
      enquire  /* "How many units?" */
		 ("쪮 ?", str);
  sscanf(str, "%d", &n); if (n<=0) n=1;
  dx=fx(XE)-fx(XI); dy=fy(YE)-fy(YI);
  un=sqrt(dx*dx+dy*dy)/n;
}

wstate(ch) char ch;
	      /* New workstate (WA, WL, WT),                 */
	      /* 'ch' is new state, 'workstate'is old state  */
	      /* 室   ࠡ祥 ﭨ :         */
	      /*  ६ 'ch'  ﭨ           */
	      /*  ६ 'workstate'- ஥            */

{ if (ch=='T')
     { if (workstate=='T') /* "Already in textmode" */
                   printf("  ⥪⮢ ०\n");
          else
    { if (colorgr) save();
	   /* So that  load()  can be  used  when  reverting */
	   /* to graphics mode later                         */
	   /* (the screen then having been  blanked  by  the */
	   /* BIOS routine  for  the color  graphics  card). */

	   /*    ᫥饬   ᪨ */
	   /* ०   ᯮ짮  㭪  load() */
	   /* (᪮  ࠦ    ࠭   梥⭮ */
	   /* ᪮   뫮   ணࠬ */
	   /*  /뢮 BIOS ).                  */

      totextmode();
    }
  }
    else
  { if (workstate=='T') togrmode();

				  /* Switch to graphics mode */
			 /* ४祭  ᪨ ० */

    textXY(8, 11,
    ch =='L' ?
    " 祭 .       " :   /* Line-drawing state */
    "᪨ ⥪⮢ ०."); /* Graphics alpha state */
    textXY(260, 0,
	  (ch=='A'?           /* "Use Ctrl WT for text mode" */
         " Ctrl WT  室  ⥪⮢ ०":
			      /* "Use WT for text mode     " */
         " WT  室  ⥪⮢ ०     "));

    penposition(0); /* up     */        /*        */
    dmode(0);       /* toggle */        /* ४ ० */
  }
  workstate=ch;
}
