/*  ணࠬ  ᭮ ᪮஢  :
   L. Ammeraal, Computer Graphics for the IBM PC (. 69),
   John Wiley, Chichester, 1987. ( .ࠫ, "設
   䨪  ᮭ ", ., 1991, . **102.
   좮 .. - ॢ  ᪨ .)
   ஬ ⮣  뫠 ᪮쪮 ஢, ⮡ 
     Lattice C   뫮  ਬ  
   Microsoft C  Turbo C.  ⮣  ࢮ ப ।-
    #define ᫥   室 ᤥ
      ᨬ᪮ ⠭ LATTICE_C ⠢
     ப ⠭ MICROSOFT_C  ࠡ  ஬
      TURBO_C, ᫨ ।⮨ ࠡ  ࡮ 
*/

/* This program  text  has  essentially  been  copied  from:
   L. Ammeraal, Computer Graphics for the IBM PC  (page 69),
   published by John Wiley, Chichester, 1987.
   It  has  been  updated   to  enable  you  to  use  either
   Microsoft C or Turbo C instead of Lattice C.
   If you are using Microsoft C,  then just change LATTICE_C
   into MICROSOFT_C in the first #define-line following this
   comment.  Similarly,  replace  LATTICE_C  with TURBO_C in
   this line if you are using Turbo C:
*/

#define TURBO_C 1

/*  ᨬ  ਬ塞    ।饩
   ப ।   ⮫쪮    ᫮:

              LATTICE_C,   MICROSOFT_C,   TURBO_C

   In  the  preceding  line,  one  of  the  three  words
   LATTICE_C, MICROSOFT_C, TURBO_C
   must occur, depending on the compiler you  are  using.
*/

/* GRPACK.C:
	An extended graphics package, by Leendert Ammeraal.
	७  ᪨        . ࠫ.
	  ਥ    ᪮  몥  ..좮,
					   䥢ࠫ 1990 .
*/
#include <dos.h>
#include <signal.h>

union REGS regs;

unsigned int _STACK = 15000;
int in_textmode=1, colorgr, X__max, Y__max, drawmode=1;
static int c1, c2, c3, old_vid_state, X1, Y1, offset;

float x_max=10.0, y_max=7.0, horfact, vertfact;
static char
   lastchar,
   gtable[12] = {53, 45, 46,  7, 91, 2, 87, 87, 2,  3,  0,  0},
   ttable[12] = {97, 80, 82, 15, 25, 6, 25, 25, 2, 13, 11, 12},
   zeros[128]; /* implicitly initialized to zero */
               /*  樠 ﬨ */

int IX(x) float x; { return (int)(x*horfact+0.5); }
int IY(y) float y; { return Y__max-(int)(y*vertfact+0.5); }

initgr()                /* Initialize graphics               */
                        /* 樠 ᪮  */
{ int brfun();
  if (!in_textmode)
      error           /* "initgr is called in graphics mode" */
           ("饭  㭪樨 initgr  ᪮ ०");
  colorgr = iscolor();
  if (colorgr < 0)    /* "Wrong display adapter" */
                   error(" ᯫ ");
  onbreak(brfun);			   /* Set break trap */
                 /* ⠭ ணࠬ ࠡ⪨ 뢠 */
  if (colorgr) initcolgr(); else initmongr();
  setgrcon(colorgr);
  in_textmode=0;
  horfact = X__max/x_max; vertfact = Y__max/y_max;
}

initcolgr()      /* Switch to graphics mode (color graphics) */
       /* ४祭  ᪨ ० (梥⭠ 䨪) */

{ regs.h.ah = 15;             /* Inquire current video state */
                  /*  ⥪饣 ﭨ  */
  int86(0x10, &regs, &regs);
  old_vid_state = regs.h.al;

  regs.h.ah = 0;            /* Set graphics mode             */
                            /* ⠭ ᪮ ० */
  regs.h.al = 6;            /* 640 x 200, black/white        */
                            /* ୮/, 640  200        */
  int86(0x10, &regs, &regs);
}

initmongr()
            /* Switch to graphics mode (monochrome graphics) */
   /* ४祭  ᪨ ० (஬ ) */

{ static int firstcall=1;
  int i;              /* See Section 2.6   -  . ࠧ 2.6 */
/*  outp(0x3BF, 3);   Step 1, already dealt with in  iscolor */
               /*  1 㦥  믮  㭪樨 'iscolor' */
  outp(0x3B8, 0x82);          /* Step 2 */         /*  2  */
  for (i=0; i<12; i++)
  { outp(0x3B4, i);
    outp(0x3B5, gtable[i]);   /* Step 3 */         /*  3  */
  }
  if (firstcall) { firstcall=0; clearpage(); }
                              /* Step 4 */         /*  4  */

  outp(0x3B8, 0x8A);          /* Step 5 */         /*  5  */
}

setgrcon(colorgr) int colorgr;
                                   /* Set graphics constants */
                        /* ନ஢ ᪨ ⠭ */
{ if (colorgr)
  { X__max = 639; Y__max = 199;
    c1 = 1; c2 = 80; c3 = 1;
  } else
  { X__max = 719; Y__max = 347;
    c1 = 3; c2 = 90; c3 = 2;
  }
}

endgr()
       /* Wait until any key is hit and revert to text mode  */
       /*     , ᫥ 祣        */
       /*    ⥪⮢ ०                         */
{ getch();
  to_text();
}

to_text()                       /* Revert to text mode       */
                                /*   ⥪⮢ ० */
{ if (in_textmode)
      error      /* "endgr or to_text is called in textmode" */
      ("㭪樨 endgr  to_text 맢  ⥪⮢ ०");
  if (colorgr) endcolgr(); else endmongr();
  in_textmode = 1;
  onbreak(0);     /* Restore default break interrupt handler */
         /* ⠭ ࠡ⪨ 뢠  㬮砭 */
}

endcolgr()          /* Revert to text mode (color graphics): */
            /*   ⥪⮢ ० ( 梥⭠ 䨪): */

{ regs.h.ah = 0; regs.h.al = old_vid_state;
  int86(0x10, &regs, &regs);
}

endmongr()     /* Revert to text mode (monochrome graphics): */
         /*   ⥪⮢ ० (஬ 䨪): */

{ int i, j;           /* See Section 2.7  -  . ࠧ 2.7  */
  outp(0x3B8, 0);                 /* Step 1 */     /*  1  */
  for (i=0; i<12; i++)
  { outp(0x3B4, i);               /* Step 2 */     /*  2  */
    outp(0x3B5, ttable[i]);
  }                                                /* Step 3 */
  for (j=0; j<256; j++) poke1(0xB000, j << 4,      /*  3  */
    "\40\7\40\7\40\7\40\7\40\7\40\7\40\7\40\7", 16);
  outp(0x3B8, 0x08);                               /* Step 4 */
}                                                  /*  4  */

static error(str) char *str;
        /* Display a message and terminate program execution */
        /* 뢮 ᮮ饭  襭 믮 ணࠬ */

{ if (!in_textmode) to_text();
  printf("%s\n", str); exit(1);
}

move(x, y) double x, y;
                        /* Move the current point to (x, y); */
                        /*  x and y are screen coordinates   */
                        /* ७ ⥪饩 窨  (x, y);   */
                        /* x  y  ࠭ न      */

{ X1 = IX(x); Y1 = IY(y); check(X1, Y1);
}

draw(x, y) double x, y;
    /* Draw a line segment from the current point to  (x, y) */
    /* 稢 १ אַ   ⥪饩 窨    */
    /*   (x, y)                                        */

{ int X2, Y2;
  X2 = IX(x); Y2 = IY(y); check(X2, Y2);
  draw_line(X1, Y1, X2, Y2);
  X1 = X2; Y1 = Y2;
}

draw_line(X1, Y1, X2, Y2) int X1, Y1, X2, Y2;
      /* Draw the line segment from (X1, Y1) to (X2, Y2);    */
      /* X1, Y1, X2, Y2 are pixel coordinates                */
      /* 稢 १ אַ  (X1, Y1)  (X2, Y2); */
      /* X1, Y1, X2, Y2 -  ᥫ न           */

{ int X, Y, T, E, dX, dY, denom, Xinc = 1, Yinc = 1,
  vertlonger = 0, aux;
  checkbreak();       /* To make DOS check for console break */
                   /* ⠭   ᮫쭮 뢠 */
  if (in_textmode)
         error       /* "Not in graphics mode (call initgr)" */
              ("  ᪮ ० (㦥 맮 initgr)");
  dX = X2 - X1; dY = Y2 - Y1;
  if (dX < 0) {Xinc = -1; dX = -dX;}
  if (dY < 0) {Yinc = -1; dY = -dY;}
  if (dY > dX) { vertlonger = 1; aux = dX; dX = dY; dY = aux; }
  denom = dX << 1;
  T = dY << 1;
  E = -dX; X = X1;
  Y = Y1;
  while (dX-- >= 0)
  { dot(X, Y);
    if ((E += T) > 0)
    { if (vertlonger) X += Xinc; else Y += Yinc;
      E -= denom;
    }
    if (vertlonger) Y += Yinc; else X += Xinc;
  }
  if (drawmode == 0) dot(X1, Y1);
}

checkbreak()
{ char ch;
  if (kbhit()) { ch = getch(); kbhit(); ungetch(ch); }
}

dot(X, Y) int X, Y;               /* Light or darken a pixel */
                            /* ᢥ⪠  襭 ᥫ */
{ int pattern;
  offset= 0x2000*(Y&c1) + c2*(Y>>c3) + (X>>3);

#ifdef LATTICE_C
  peek(0xB800, offset, &lastchar, 1);
#else
  lastchar = *(char far *)(0xB8000000L + offset);
#endif

  pattern = 0x80 >> (X&7);
  if (drawmode == 1) lastchar |= pattern; else
  if (drawmode == -1) lastchar &= (~pattern);
                 else lastchar ^= pattern;

#ifdef LATTICE_C
  poke(0xB800, offset, &lastchar, 1);
#else
  *(char far *)(0xB8000000L + offset) = lastchar;
#endif

}

int pixlit(X, Y) int X, Y;
                           /* Inquire if pixel (X, Y) is lit */
                   /* ,  ᢥ祭  ᥫ (X, Y) */

{ int pattern;
  offset= 0x2000*(Y&c1) + c2*(Y>>c3) + (X>>3);
                /* c1, c2 and c3 have been defined in initgr */
                /* c1, c2    c3  뫨 ।  'initgr' */
  pattern = 0x80 >> (X&7);

#ifdef LATTICE_C
  peek(0xB800, offset, &lastchar, 1);
#else
  lastchar = *(char far *)(0xB8000000L + offset);
#endif

  return ((lastchar & pattern) != 0);
}

clearpage()                              /* Clear the screen */
                                         /* ⪠ ࠭   */
{ int i, n;
  n=(colorgr ? 128 : 256);
  for (i=0; i<n; i++) poke1(0xB800, i << 7, zeros, 128);
}

int iscolor()              /* Find out which adapter is used */
                  /* । ⨯ ᯮ㥬  */

{ char ch0, ch1, x;
  int86(0x11, &regs, &regs);
  if ((regs.x.ax & 0x30) != 0x30)
       return 1;                           /* Color graphics */
                              /* ⭮ ᪨  */
  outp(0x3BF, 3);   /* Configuration switch, see Section 2.6 */
               /* ४⥫ 䨣樨, . ࠧ 2.6 */
  peek1(0xB800, 0, &ch0, 1);
                       /* Try to read ch0 from screen memory */
                 /* ⪠  ch0  ࠭  */
  ch1 = ch0 ^ 0xFF;   /* Find some value different from  ch0 */
           /* । ண ᫠, ⫨筮  ch0 */
  poke1(0xB800, 0, &ch1, 1);
                     /* Try to write this into screen memory */
             /* ⪠   ᫮  ࠭  */
  peek1(0xB800, 0, &x, 1);
                             /* Try to read the latter value */
                 /* ⪠   ᫥ 祭 */
  poke1(0xB800, 0, &ch0, 1);
                               /* Restore the old value  ch0 */
                      /* ⠭ ண 祭 ch0 */
  return ( x == ch1 ? 0 : -1);
                             /* Has written value been read? */
                      /* 뫮  ⠭ ᠭ ᫮? */
}

fatal()
     /* Draw a diagonal, then wait until  a key  is pressed, */
     /* and  finally revert to text mode.                    */
     /* 稢    ࠭, ⥬  */
     /*      ⥫쭮  室 */
     /*  ⥪⮢ ०.                                   */

{ draw_line(0, Y__max,  X__max, 0); endgr();
}

check(X, Y) int X, Y;

  /* If point (X, Y)  lies  outside  the screen  boundaries, */
  /* then call fatal,  print the wrong coordinates, and stop */
  /* ᫨ 窠 (X, Y)    । ࠭,   맮 */
  /* 㭪樨 fatal, ⮡ࠦ  न  ⠭ */

{ if (X < 0 || X > X__max || Y < 0 || Y > Y__max)
  { fatal();
    printf
    /* "Point outside screen (X and Y are pixel coordinates" */
      ("窠  ࠭ (X  Y  ᥫ न):\n");
    printf("X = %d       Y = %d\n", X, Y);
    printf("x = %10.3f   y = %10.3f\n",
    X/horfact, (Y__max-Y)/vertfact);
    exit(1);
  }
}

int brfun()   /*   Used by  onbreak, to specify  what to do  */
              /*   with a console break                      */
	      /* ᯮ 㭪樥 onbreak    ।- */
              /* ,    ᮫쭮 뢠 */

{ if (!in_textmode) to_text();
  exit(0);              /* Before exit, return to text mode! */
                /* । 室   ⥪⮢ ० ! */
  return 1;                      /* This is only a formality */
                                  /*  ⮫쪮 ଠ쭮 */
}

fill(x, y) float x, y;
         /* Fill a closed area, starting in point (x, y)     */
         /* x and y are screen coordinates, in inches        */
         /*  ⮩ , 稭  窨    */
         /* (x, y),  x  y - ࠭ न   */

{ pixfill(IX(x), IY(y));
}

pixfill(X, Y) int X, Y;
           /* Fill a closed region, starting in point (X, Y) */
           /*   ,  稭    窨 (X, Y) */

{ int Xleft, Xright, YY, i, dm;
  char ones=0xFF;
  dm=drawmode; drawmode=1;
  check(X, Y);
  checkbreak();       /* To make DOS check for console break */
                   /* ⠭   ᮫쭮 뢠 */
        /* Light as many pixels as possible on line Y,       */
        /* and determine Xleft and Xright:                   */
        /* ᢥ⪠ ᨬ쭮 ⢠ ᥫ       */
        /*  ப Y  । 祭 Xleft  Xright: */
  Xleft=Xright=X;
  while (pixlit(Xleft, Y) == 0 && Xleft >= 0)
  { if (lastchar == 0)
    {

#ifdef LATTICE_C
      poke(0xB800, offset, &ones, 1);
#else
      *(char far *)(0xB8000000L + offset) = ones;
#endif

      Xleft &= 0xFFF8;
      if (Xright == X) Xright |= 7;
    } else dot(Xleft, Y);
    Xleft--;
  }
  Xright++;
  while (pixlit(Xright, Y) == 0 && Xright <= X__max)
  { if (lastchar == 0)
    {

#ifdef LATTICE_C
      poke(0xB800, offset, &ones, 1);
#else
      *(char far *)(0xB8000000L + offset) = ones;
#endif

      Xright |= 7;
    } else dot(Xright, Y);
    Xright++;
  }
                 /* Recursive calls of pixfill for at most   */
                 /* two remote points:                       */
                 /* ᨢ  饭  㭪樨 pixfill */
                 /*    㤠 祪:       */

  X = (Xleft+Xright) >> 1;
  for (i=-1; i <= 1; i += 2)
  { YY=Y+i;
    while (pixlit(X, YY) == 0) YY += i;
    YY = (Y+YY) >> 1;
    if (pixlit(X, YY) == 0) pixfill(X, YY);
  }
       /* Recursive calls for all dark pixels next to line Y */
       /* (with X values between Xleft and Xright):          */
       /* ᨢ 맮   ⥬ ᥫ,       */
       /* 室 冷  ப Y                     */
       /* ( 祭 X  Xleft  Xright):            */

  for (YY=Y-1; YY<=Y+1; YY+=2)
  { X=Xleft+1;
    while (X < Xright)
    { i=pixlit(X, YY);
      if (lastchar == ones) X |= 7; else
      if (i == 0) pixfill(X, YY);
      X++;
    }
  }
  drawmode=dm;
}

prchar(ch) char ch;
           /* 뫪  ch  ࠫ  ਭ */

{ regs.x.dx=0;    /* 롮 ਭ                          */
  regs.h.ah=0;    /* 뫪   ॣ AL  ਭ */
  regs.h.al=ch;   /* , 뫠  ਭ             */
  int86(0x17, &regs, &regs);
}

printgr(Xlo, Xhi, Ylo, Yhi) int Xlo, Xhi, Ylo, Yhi;
            /* Print contents of rectangle on matrix printer */
            /* 뢮 ᮤন אַ㣮쭨   */
            /* ਭ                                       */

{ int n1, n2, ncols, i, X, Y, val;
  prchar(27); prchar('1');         /* Line spacing 7/72 inch */
                   /*  ﭨ   ப 7/72  */
  ncols=Xhi-Xlo+1;
  n1=ncols%256; n2=ncols/256;
  for (i=Ylo; i<=Yhi; i+=7)
  { checkbreak();     /* To make DOS check for console break */
         /*  ⠭   ஢ન ᮫쭮 뢠 */
    prchar(27); prchar('L'); prchar(n1); prchar(n2);
    for (X=Xlo; X<=Xhi; X++)
    { val=0;
      for (Y=i; Y<i+7; Y++)
      { val <<= 1; val |= (Y>Yhi ? 0 : pixlit(X, Y));
      }
      prchar(val);
    }
    prchar('\n');
  }
  prchar(27); prchar('@');
}

setprdim()
    /* This function sets x_max and y_max such that graphics */
    /* results  will  eventually  be  printed  with  correct */
    /* dimensions,  both  horizontally  and  vertically.     */

    /*  㭪  ⠭  祭  x_max    y_max */
    /*   ⠪  ⮬,  ⮡   ᪮  ࠦ */
    /* 뫮  뢥      ᮡ  ࠧ஢   */
    /*   ਧ⠫, ⠪      ⨪.               */

{ extern float x_max, y_max;
  extern int X__max, Y__max;
  setgrcon(iscolor());
  x_max = (X__max + 1)/120.0; y_max=(Y__max + 1)/72.0;
}

       /* The following program text discussed in Chapter 5. */
       /*  ᫥饩 ࠬ 㦤   5.    */

#define NASCII 256
char chlist[NASCII][11]=
{
  {0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},
  {0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},	{0},  {0},
  {0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},
/* */   {0},
/*!*/ {0x10, 0x38, 0x38, 0x38, 0x10, 0x10, 0x10,    0, 0x10},
/*"*/ {0x48, 0x48, 0x48},
/*#*/ {0x24, 0x24, 0x64, 0xFE, 0x44, 0xFE, 0x4C, 0x48, 0x48},
/*$*/ {0x10, 0x7C, 0xD0, 0xD0, 0x7C, 0x16, 0x16, 0x7C, 0x10},
/*%*/ {0xC2, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80, 0x86},
/*&*/ {0x30, 0x48, 0x48, 0x30, 0x50, 0x92, 0x8A, 0x8C, 0x72},
/*'*/ {0x18, 0x18, 0x18, 0x10},
/*(*/ {0x08, 0x10, 0x20, 0x20, 0x20, 0x20, 0x20, 0x10, 0x08},
/*)*/ {0x40, 0x20, 0x10, 0x10, 0x10, 0x10, 0x10, 0x20, 0x40},
/***/ {   0, 0x82, 0x44, 0x28, 0xFE, 0x28, 0x44, 0x82},
/*+*/ {   0, 0x10, 0x10, 0x10, 0xFE, 0x10, 0x10, 0x10},
/*,*/ {0, 0, 0, 0, 0, 0,    0, 0x30, 0x30, 0x10, 0x20},
/*-*/ {0, 0, 0, 0, 0xFE},
/*.*/ {0, 0, 0, 0, 0, 0,    0, 0x30, 0x30},
/*/*/ {   0, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80},
/*0*/ {0x38, 0x6C, 0x44, 0x44, 0x44, 0x44, 0x44, 0x6C, 0x38},
/*1*/ {0x10, 0x30, 0x50, 0x10, 0x10, 0x10, 0x10, 0x10, 0x38},
/*2*/ {0x7C, 0xC6, 0x02, 0x06, 0x0C, 0x18, 0x30, 0x60, 0xFE},
/*3*/ {0x7C, 0xC6, 0x02, 0x06, 0x0C, 0x06, 0x02, 0xC6, 0x7C},
/*4*/ {0x04, 0x0C, 0x1C, 0x34, 0x64, 0xC4, 0xFE, 0x04, 0x04},
/*5*/ {0xFE, 0x80, 0x80, 0xFC, 0x06, 0x02, 0x02, 0xC6, 0x7C},
/*6*/ {0x7C, 0xC6, 0x80, 0xFC, 0xC6, 0x82, 0x82, 0xC6, 0x7C},
/*7*/ {0xFE, 0x02, 0x06, 0x0C, 0x18, 0x30, 0x60, 0xC0, 0x80},
/*8*/ {0x7C, 0xC6, 0x82, 0xC6, 0x7C, 0xC6, 0x82, 0xC6, 0x7C},
/*9*/ {0x7C, 0xC6, 0x82, 0xC2, 0x7E, 0x02, 0x02, 0x06, 0x7C},
/*:*/ {   0, 0x30, 0x30, 0, 0, 0, 0, 0x30, 0x30},
/*;*/ {0, 0, 0x30, 0x30, 0, 0,    0, 0x30, 0x30, 0x10, 0x20},
/*<*/ {0x04, 0x08, 0x10, 0x20, 0x40, 0x20, 0x10, 0x08, 0x04},
/*=*/ {0, 0, 0, 0, 0xFC, 0, 0, 0xFC},
/*>*/ {0x40, 0x20, 0x10, 0x08, 0x04, 0x08, 0x10, 0x20, 0x40},
/*?*/ {0x78, 0xCC, 0x84, 0x0C, 0x18, 0x10, 0x10, 0,    0x10},
/*@*/ {0x7C, 0xC6, 0x8E, 0x92, 0x92, 0x92, 0x8C, 0xC0, 0x7C},
/*A*/ {0x10, 0x38, 0x6C, 0xC6, 0x82, 0x82, 0xFE, 0x82, 0x82},
/*B*/ {0xFC, 0x86, 0x82, 0x86, 0xFC, 0x86, 0x82, 0x86, 0xFC},
/*C*/ {0x7C, 0xC6, 0x80, 0x80, 0x80, 0x80, 0x80, 0xC6, 0x7C},
/*D*/ {0xFC, 0x86, 0x82, 0x82, 0x82, 0x82, 0x82, 0x86, 0xFC},
/*E*/ {0xFE, 0x80, 0x80, 0x80, 0xF8, 0x80, 0x80, 0x80, 0xFE},
/*F*/ {0xFE, 0x80, 0x80, 0x80, 0xFC, 0x80, 0x80, 0x80, 0x80},
/*G*/ {0x7C, 0xC6, 0x82, 0x80, 0x80, 0x8E, 0x82, 0xC6, 0x7C},
/*H*/ {0x82, 0x82, 0x82, 0x82, 0xFE, 0x82, 0x82, 0x82, 0x82},
/*I*/ {0x38, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x38},
/*J*/ {0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0xC6, 0x7C},
/*K*/ {0x86, 0x8C, 0x98, 0xB0, 0xE0, 0xB0, 0x98, 0x8C, 0x86},
/*L*/ {0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0xFE},
/*M*/ {0x82, 0xC6, 0xEE, 0xBA, 0x92, 0x82, 0x82, 0x82, 0x82},
/*N*/ {0x82, 0xC2, 0xE2, 0xA2, 0xB2, 0x9A, 0x8E, 0x86, 0x82},
/*O*/ {0x7C, 0xC6, 0x82, 0x82, 0x82, 0x82, 0x82, 0xC6, 0x7C},
/*P*/ {0xFC, 0x86, 0x82, 0x86, 0xFC, 0x80, 0x80, 0x80, 0x80},
/*Q*/ {0x7C, 0xC6, 0x82, 0x82, 0x82, 0x82, 0x92, 0xD6, 0x7C, 0x08, 0x08},
/*R*/ {0xFC, 0x86, 0x82, 0x86, 0xFC, 0x90, 0x98, 0x8C, 0x86},
/*S*/ {0x7C, 0xC6, 0x80, 0xC0, 0x7C, 0x06, 0x02, 0xC6, 0x7C},
/*T*/ {0xFE, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10},
/*U*/ {0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0xC6, 0x7C},
/*V*/ {0x82, 0x82, 0x82, 0xC6, 0x44, 0x6C, 0x28, 0x38, 0x10},
/*W*/ {0x82, 0x82, 0x82, 0x92, 0x92, 0xBA, 0xEE, 0x6C, 0x44},
/*X*/ {0xC6, 0x44, 0x6C, 0x28, 0x38, 0x28, 0x6C, 0x44, 0xC6},
/*Y*/ {0x82, 0x82, 0xC6, 0x6C, 0x38, 0x10, 0x10, 0x10, 0x10},
/*Z*/ {0xFE, 0x04, 0x0C, 0x18, 0x10, 0x30, 0x60, 0x40, 0xFE},
/*[*/ {0x7C, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x7C},
/*\*/ {   0, 0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02},
/*]*/ {0x78, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x78},
/*^*/ {0x10, 0x28, 0x44, 0x82},
/*_*/ {0, 0, 0, 0, 0, 0, 0, 0, 0xFE},
/*`*/ {0x40, 0x20, 0x10, 0x08},
/*a*/ {0, 0,    0, 0x7C, 0x06, 0x7E, 0xC2, 0xC2, 0x7E},
/*b*/ {0x80, 0x80, 0x80, 0xFC, 0x86, 0x82, 0x82, 0x86, 0xFC},
/*c*/ {0, 0,    0, 0x7C, 0xC6, 0x80, 0x80, 0xC6, 0x7C},
/*d*/ {0x04, 0x04, 0x04, 0x7C, 0xC4, 0x84, 0x84, 0xC4, 0x7C},
/*e*/ {0, 0,    0, 0x7C, 0xC6, 0xFE, 0x80, 0xC0, 0x7C},
/*f*/ {0x1C, 0x30, 0x20, 0xFC, 0x20, 0x20, 0x20, 0x20, 0x20},
/*g*/ {0, 0,    0, 0x7A, 0xCE, 0x82, 0x82, 0xC2, 0x7E, 0x06, 0x7C},
/*h*/ {0x80, 0x80, 0x80, 0xFC, 0xC6, 0x82, 0x82, 0x82, 0x82},
/*i*/ {   0, 0x30,    0, 0x30, 0x10, 0x10, 0x10, 0x10, 0x38},
/*j*/ {   0, 0x0C,    0, 0x0C, 0x04, 0x04, 0x04, 0x04, 0x04, 0xCC, 0x78},
/*k*/ {0x40, 0x40, 0x40, 0x46, 0x4C, 0x78, 0x58, 0x4C, 0x46},
/*l*/ {0x30, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x38},
/*m*/ {0, 0,    0, 0xEC, 0x92, 0x92, 0x92, 0x92, 0x92},
/*n*/ {0, 0,    0, 0xBC, 0xC6, 0x82, 0x82, 0x82, 0x82},
/*o*/ {0, 0,    0, 0x7C, 0xC6, 0x82, 0x82, 0xC6, 0x7C},
/*p*/ {0, 0,    0, 0xFC, 0x86, 0x82, 0x82, 0x86, 0xFC, 0x80, 0x80},
/*q*/ {0, 0,    0, 0x7C, 0xC4, 0x84, 0x84, 0xC4, 0x7C, 0x04, 0x06},
/*r*/ {0, 0,    0, 0xBC, 0xE6, 0x80, 0x80, 0x80, 0x80},
/*s*/ {0, 0,    0, 0x7C, 0xC0, 0x7C, 0x06, 0x06, 0x7C},
/*t*/ {   0, 0x40, 0x40, 0xF0, 0x40, 0x40, 0x40, 0x66, 0x3C},
/*u*/ {0, 0,    0, 0x84, 0x84, 0x84, 0x84, 0xC4, 0x7E},
/*v*/ {0, 0,    0, 0x82, 0x82, 0xC6, 0x6C, 0x38, 0x10},
/*w*/ {0, 0,    0, 0x82, 0x82, 0x92, 0xBA, 0xEE, 0x44},
/*x*/ {0, 0,    0, 0xC6, 0x6C, 0x28, 0x38, 0x6C, 0xC6},
/*y*/ {0, 0,    0, 0x82, 0x82, 0x82, 0x82, 0xC6, 0x7E, 0x06, 0x7C},
/*z*/ {0, 0,    0, 0xFE, 0x0C, 0x18, 0x30, 0x60, 0xFE},
/*{*/ {0x10, 0x20, 0x20, 0x20, 0x40, 0x20, 0x20, 0x20, 0x10},
/*|*/ {0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10},
/*}*/ {0x20, 0x10, 0x10, 0x10, 0x08, 0x10, 0x10, 0x10, 0x20},
/*~*/ {0, 0,    0, 0x60, 0x92, 0x0C}, {0},
/**/ {0x3E, 0x42, 0x82, 0x82, 0x82, 0xFE, 0x82, 0x82, 0x82},
/**/ {0xFC, 0x80, 0x80, 0xFC, 0x82, 0x82, 0x82, 0x82, 0xFC},
/*B*/ {0xFC, 0x82, 0x82, 0x84, 0xFC, 0x82, 0x82, 0x82, 0xFC},
/**/ {0xFC, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80},
/**/ {0x1C, 0x24, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0xFE, 0x82},
/**/ {0xFC, 0x80, 0x80, 0x80, 0xF8, 0x80, 0x80, 0x80, 0xFC},
/**/ {0x92, 0x92, 0x54, 0x38, 0x38, 0x54, 0x92, 0x92, 0x92},
/**/ {0x3C, 0x42, 0x02, 0x04, 0x3C, 0x02, 0x02, 0x82, 0x7C},
/**/ {0x82, 0x82, 0x86, 0x8E, 0x9A, 0xB2, 0xE2, 0xC2, 0x82},
/**/ {0xBA, 0x82, 0x86, 0x8E, 0x9A, 0xB2, 0xE2, 0xC2, 0x82},
/**/ {0x84, 0x84, 0x84, 0x88, 0xF0, 0x88, 0x84, 0x82, 0x82},
/**/ {0x1E, 0x22, 0x42, 0x42, 0x42, 0x42, 0x42, 0xC2, 0xC2},
/**/ {0x82, 0xC6, 0xEE, 0xBA, 0x92, 0x82, 0x82, 0x82, 0x82},
/**/ {0x82, 0x82, 0x82, 0x82, 0xFE, 0x82, 0x82, 0x82, 0x82},
/**/ {0x7C, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x7C},
/**/ {0xFE, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82},
/**/ {0xFC, 0x82, 0x82, 0x82, 0x82, 0xFC, 0x80, 0x80, 0x80},
/**/ {0x7C, 0x82, 0x80, 0x80, 0x80, 0x80, 0x80, 0x82, 0x7C},
/**/ {0xFE, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10},
/**/ {0x82, 0x82, 0x82, 0x82, 0x82, 0x7E, 0x02, 0x02, 0x7C},
/**/ {0x10, 0x7C, 0x92, 0x92, 0x92, 0x92, 0x7C, 0x10, 0x10},
/**/ {0x82, 0xC6, 0x6C, 0x38, 0x10, 0x28, 0x6C, 0xC6, 0x82},
/**/ {0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x7E, 0x06},
/**/ {0x82, 0x82, 0x82, 0x82, 0x82, 0x7E, 0x02, 0x02, 0x02},
/**/ {0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x7E},
/**/ {0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0xFE, 0x06},
/**/ {0xC0, 0xC0, 0x40, 0x7C, 0x42, 0x42, 0x42, 0x42, 0x7C},
/**/ {0x82, 0x82, 0x82, 0xF2, 0x8A, 0x8A, 0x8A, 0x8A, 0xF2},
/**/ {0x80, 0x80, 0x80, 0xFC, 0x82, 0x82, 0x82, 0x82, 0xFC},
/**/ {0x7C, 0x82, 0x02, 0x02, 0x3E, 0x02, 0x02, 0x82, 0x7C},
/**/ {0x9C, 0xA2, 0xA2, 0xA2, 0xA2, 0xE2, 0xA2, 0xA2, 0x9C},
/**/ {0x3E, 0x42, 0x42, 0x42, 0x42, 0x3E, 0x22, 0x42, 0x82},
/**/ {0, 0,    0, 0x78, 0x04, 0x7C, 0x84, 0x84, 0x7A},
/**/ {0, 0, 0x78, 0x80, 0xF8, 0x84, 0x84, 0x84, 0x78},
/**/ {0, 0,    0, 0xF8, 0x84, 0xF8, 0x84, 0x84, 0xF8},
/**/ {0, 0,    0, 0xFC, 0x80, 0x80, 0x80, 0x80, 0x80},
/**/ {0, 0, 0x78, 0x04, 0x7C, 0x84, 0x84, 0x84, 0x78},
/**/ {0, 0,    0, 0x78, 0x84, 0x84, 0xF8, 0x80, 0x7C},
/**/ {0, 0,    0, 0x92, 0x54, 0x38, 0x38, 0x54, 0x92},
/**/ {0, 0,    0, 0x78, 0x84, 0x18, 0x04, 0x84, 0x78},
/**/ {0, 0,    0, 0x84, 0x8C, 0x94, 0xA4, 0xC4, 0x84},
/**/ {0, 0, 0x30, 0x84, 0x8C, 0x94, 0xA4, 0xC4, 0x84},
/**/ {0, 0,    0, 0x84, 0x88, 0xF0, 0x88, 0x84, 0x82},
/**/ {0, 0,    0, 0x3C, 0x44, 0x44, 0x44, 0x44, 0x84},
/**/ {0, 0,    0, 0x82, 0xC6, 0xAA, 0x92, 0x82, 0x82},
/**/ {0, 0,    0, 0x84, 0x84, 0x84, 0xFC, 0x84, 0x84},
/**/ {0, 0,    0, 0x78, 0x84, 0x84, 0x84, 0x84, 0x78},
/**/ {0, 0,    0, 0xFC, 0x84, 0x84, 0x84, 0x84, 0x84},
	{0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},
	{0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},
	{0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},
	{0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},
	{0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},
/**/ {0, 0,    0, 0xF8, 0x84, 0x84, 0x84, 0x84, 0xF8, 0x80, 0x80},
/**/ {0, 0,    0, 0x78, 0x84, 0x80, 0x80, 0x84, 0x78},
/**/ {0, 0,    0, 0xFE, 0x10, 0x10, 0x10, 0x10, 0x10},
/**/ {0, 0,    0, 0x84, 0x84, 0x84, 0x84, 0x84, 0x7C, 0x04, 0x78},
/**/ {0,0,  0x10, 0x7C, 0x92, 0x92, 0x92, 0x92, 0x7C, 0x10, 0x10},
/**/ {0, 0,    0, 0x84, 0x48, 0x30, 0x30, 0x48, 0x84},
/**/ {0, 0,    0, 0x84, 0x84, 0x84, 0x84, 0x84, 0x7E, 0x06},
/**/ {0, 0,    0, 0x84, 0x84, 0x84, 0x7C, 0x04, 0x04},
/**/ {0, 0,    0, 0x92, 0x92, 0x92, 0x92, 0x92, 0x7E},
/**/ {0, 0,    0, 0x92, 0x92, 0x92, 0x92, 0x92, 0x7E, 0x03},
/*'*/ {0, 0,    0, 0xC0, 0x40, 0x78, 0x44, 0x44, 0x78},
/**/ {0, 0,    0, 0x82, 0x82, 0xF2, 0x8A, 0x8A, 0xF2},
/**/ {0, 0,    0, 0x80, 0x80, 0xF8, 0x84, 0x84, 0xF8},
/**/ {0, 0,    0, 0x78, 0x84, 0x04, 0x3C, 0x84, 0x78},
/**/ {0, 0,    0, 0x98, 0xA4, 0xA4, 0xE4, 0xA4, 0x98},
/**/ {0, 0,    0, 0x3C, 0x44, 0x44, 0x3C, 0x44, 0x84},
	{0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},
	{0},  {0},  {0},  {0},  {0},  {0},  {0},  {0} };

textXY(X, Y, str) int X, Y; char *str;
		 /* Display string  str  in  graphics  mode, */
                 /* starting at point (X, Y).                */
		 /* ⮡ࠦ ⥪⮢ ப  str  - */
                 /* ᪮ ०, 稭  窨 (X, Y). */

{ char *p;
  int offset, i, j, len, hpos, vpos;
  len=strlen(str);
  hpos = X>>3;
  check(8*(hpos+len)-1, Y+10);
  for (i=0; i<len; i++)
  { p=chlist[str[i]];
    for (j=0; j<11; j++)
    { vpos=Y+j;
      offset= 0x2000*(vpos&c1) + c2*(vpos>>c3) + hpos + i;
      poke1(0xB800, offset, (char *)(p+j), 1);
    }
  }
}

text(str) char *str;   /* Display string  str, starting at   */
                       /* the current point (X1, Y1).        */
                       /* ⮡ࠦ ⥪⮢ ப str,  */
                       /* 稭  ⥪饩 窨 (X1, Y1).  */
{ textXY(X1, Y1, str);
  X1 += strlen(str) * 8;
  check(X1, Y1);
}

imove(X, Y) int X, Y;
           /* Let (X, Y) be the new current point            */
           /* 窠 (X, Y) 㤥 ⥯  ⥪饩 窮 */
{ check(X, Y); X1=X; Y1=Y;
}

idraw(X, Y) int X, Y;
     /* Draw a line segment from the current point to (X, Y) */
     /* 稢 १ אַ   ⥪饩 窨   */
     /*   (X, Y).                                      */
{ check(X, Y);
  draw_line(X1, Y1, X, Y);
  X1=X; Y1=Y;
}

circle(xC, yC, R) float xC, yC, R;
      /* Display a circle with given center and radius       */
      /* ࠦ 㦭   業  ࠤ */

{ double cosd, sind, costh, sinth, c0, s0;
  int i, XC, YC, H, H0, V, V0;         /*  delta = pi / 40   */
  cosd = 0.996917333733120;            /*  cosd = cos delta  */
  sind = 0.078459095727844;            /*  sind = sin delta  */
  costh = 1.0; H = (int)(R * horfact + 0.5);
  sinth = 0.0; V = 0;
                    /* costh = cos theta,  sinth = sin theta,
					   theta = i * delta */
  XC = IX(xC); YC = IY(yC);
  if (drawmode == 0) { dot(XC+H, YC); dot(XC-H, YC); }
  for (i=1; i<=20; i++)
  { c0 = costh; s0 = sinth; H0 = H; V0 = V;
    costh = c0 * cosd - s0 * sind;
    sinth = s0 * cosd + c0 * sind;
    H = (int)(R * costh * horfact + 0.5);
    V = (int)(R * sinth * vertfact + 0.5);
    draw_line(XC+H0, YC+V0, XC+H, YC+V);
    draw_line(XC-H0, YC+V0, XC-H, YC+V);
    draw_line(XC+H0, YC-V0, XC+H, YC-V);
    draw_line(XC-H0, YC-V0, XC-H, YC-V);
  }
  if (drawmode == 0) { dot(XC, YC+V); dot(XC, YC-V); }
}

#ifndef LATTICE_C
       /* The following applies to Microsoft C and Turbo C: */
       /*   ਬ     ࡮ : */

poke1(segment, offset, buffer, n)
   unsigned segment, offset, n; char *buffer;
{ unsigned srcseg, srcoff;
  char far *p = (char far *)buffer;
  srcseg = FP_SEG(p);
  srcoff = FP_OFF(p);
  movedata(srcseg, srcoff, segment, offset, n);
}

peek1(segment, offset, buffer, n)
   unsigned segment, offset, n; char *buffer;
{ unsigned destseg, destoff;
  char far *p = (char far *)buffer;
  destseg = FP_SEG(p);
  destoff = FP_OFF(p);
  movedata(segment, offset, destseg, destoff, n);
}

#endif

#ifdef MICROSOFT_C

int onbreak(brfun) int (*brfun)();
{ if (brfun == 0) signal(SIGINT, SIG_DFL);
             else signal(SIGINT, brfun);
}

#endif

#ifdef TURBO_C

int onbreak(brfun) int (*brfun)();
{ ctrlbrk(brfun);
}

#endif

#ifdef LATTICE_C

poke1(segment, offset, buffer, n)
   unsigned segment, offset, n; char *buffer;
{ poke(segment, offset, buffer, n);
}

peek1(segment, offset, buffer, n)
   unsigned segment, offset, n; char *buffer;
{ peek(segment, offset, buffer, n);
}

#endif