/* ᠭ ணࠬ .   .ࠫ, "設 䨪
    ᮭ ", ., 1991, . **50.
   좮 .. - ॢ  ᪨ .

   This program text has been copied from:
   L. Ammeraal, Computer Graphics for the IBM PC  (page 31),
   published by John Wiley, Chichester, 1987.
*/
/* LINDRAW.C:  ணࠬ  稢 .

	       ਠ  LINDRAW ਣ ⮫쪮 
	       Lattice C.  㣨 ஢
	      ४ ਬ   
	      ᪥   . ࠫ. "ਭ樯
	      ணࠬ஢  設 䨪", ., 1991.

	      A package of routines for line drawing, see also
              PROGRAMMING PRINCIPLES IN COMPUTER GRAPHICS,
              by L. Ammeraal                                */

#include "dos.h"

union REGS regs;

unsigned int _STACK = 15000;
int in_textmode=1, colorgr, X__max, Y__max;
static int c1, c2, c3, old_vid_state, X1, Y1;
float x_max=10.0, y_max=7.0, horfact, vertfact;
static char
   gtable[12] = {53, 45, 46,  7, 91, 2, 87, 87, 2,  3,  0,  0},
   ttable[12] = {97, 80, 82, 15, 25, 6, 25, 25, 2, 13, 11, 12},
   zeros[128];               /* implicitly initialized to zero */
			     /*  樠 ﬨ */

int IX(x) float x; { return (int)(x*horfact+0.5); }
int IY(y) float y; { return Y__max-(int)(y*vertfact+0.5); }

initgr()                  /* Initialize graphics               */
			  /* 樠 ᪮  */
{ int brfun();
  if (!in_textmode) error /* initgr is called in graphics mode */
             ("饭  㭪樨 initgr  ᪮ ०");
  colorgr = iscolor();
  if (colorgr < 0) error /* Wrong display adapter */
			 (" ᯫ ");
  onbreak(brfun);  /* Set break trap                           */
		   /* ⠭ ணࠬ ࠡ⪨ 뢠 */
  if (colorgr)
  { initcolgr();       /* Enter graphics mode (color graphics) */
	      /* 室  ᪨ ० (梥⭠ 䨪) */
    X__max = 639; Y__max = 199;
    c1 = 1; c2 = 80; c3 = 1;
  } else
  { initmongr();   /* Enter graphics mode (monochrome graphics */
	  /* 室  ᪨ ० (஬ 䨪) */
    X__max = 719; Y__max = 347;
    c1 = 3; c2 = 90; c3 = 2;
  }
  in_textmode=0;
  horfact = X__max/x_max; vertfact = Y__max/y_max;
}

initcolgr()        /* Switch to graphics mode (color graphics) */
	 /* ४祭  ᪨ ० (梥⭠ 䨪) */
{ regs.h.ah = 15;   /* Inquire current video state             */
		    /*  ⥪饣 ﭨ  */
  int86(0x10, &regs, &regs);
  old_vid_state = regs.h.al;

  regs.h.ah = 0;              /* Set graphics mode             */
			      /* ⠭ ᪮ ० */
  regs.h.al = 6;              /* 640 x 200, black/white        */
                              /* ୮/, 640  200        */
  int86(0x10, &regs, &regs);
}

initmongr()
	      /* Switch to graphics mode (monochrome graphics) */
     /* ४祭  ᪨ ० (஬ 䨪) */

{ int i, j;           /* See Section 2.6  */ /* . ࠧ 2.6 */
/*  outp(0x3BF, 3);     Step 1, already dealt with in  iscolor */
		 /*  1 㦥  믮  㭪樨 'iscolor' */
  outp(0x3B8, 0x82);            /* Step 2 */         /*  2  */

  for (i=0; i<12; i++)
  { outp(0x3B4, i);
    outp(0x3B5, gtable[i]);     /* Step 3 */         /*  3  */
  }
  for (j=0; j<256; j++) poke(0xB800, j << 7, zeros, 128);
				/* Step 4 */         /*  4  */
  outp(0x3B8, 0x8A);            /* Step 5 */         /*  5  */
}

endgr()
	 /* Wait until any key is hit and revert to text mode  */
	 /*     , ᫥ 祣        */
	 /*    ⥪⮢ ०                         */
{ getch();
  to_text();
}

to_text()				/* Revert to text mode */
				  /*   ⥪⮢ ० */
{ if (in_textmode)
      error  /* "endgr or to_text is called in textmode" */
	("㭪樨 endgr  to_text 맢  ⥪⮢ ०");
  if (colorgr) endcolgr(); else endmongr();
  in_textmode = 1;
  onbreak(0);       /* Restore default break interrupt handler */
	   /* ⠭ ࠡ⪨ 뢠  㬮砭 */
}

endcolgr()	      /* Revert to text mode (color graphics): */
	      /*   ⥪⮢ ० ( 梥⭠ 䨪): */
{ regs.h.ah = 0; regs.h.al = old_vid_state;
  int86(0x10, &regs, &regs);
}

endmongr()       /* Revert to text mode (monochrome graphics): */
	   /*   ⥪⮢ ० (஬ 䨪): */

{ int i, j;             /* See Section 2.7  -  . ࠧ 2.7  */
  outp(0x3B8, 0);                   /* Step 1 */     /*  1  */
  for (i=0; i<12; i++)
  { outp(0x3B4, i);                 /* Step 2 */     /*  2  */
    outp(0x3B5, ttable[i]);
  }                                                  /* Step 3 */
  for (j=0; j<256; j++) poke1(0xB000, j << 4,        /*  3  */
    "\40\7\40\7\40\7\40\7\40\7\40\7\40\7\40\7", 16);
  outp(0x3B8, 0x08);                                 /* Step 4 */
}                                                    /*  4  */

error(str) char *str;
	  /* Display a message and terminate program execution */
	  /* 뢮 ᮮ饭  襭 믮 ணࠬ */

{ if (!in_textmode) to_text();
  printf("%s\n", str); exit(1);
}

move(x, y) double x, y;	  /* Move the current point to (x, y); */
			  /*  x and y are screen coordinates   */
			  /* ७ ⥪饩 窨  (x, y);   */
			  /* x  y  ࠭ न      */

{ X1 = IX(x); Y1 = IY(y); check(X1, Y1);
}

draw(x, y) double x, y;
      /* Draw a line segment from the current point to  (x, y) */
      /* 稢 १ אַ   ⥪饩 窨    */
      /*   (x, y)                                        */

{ int X2, Y2;
  X2 = IX(x); Y2 = IY(y); check(X2, Y2);
  draw_line(X1, Y1, X2, Y2);
  X1 = X2; Y1 = Y2;
}

draw_line(X1, Y1, X2, Y2) int X1, Y1, X2, Y2;
	/* Draw the line segment from (X1, Y1) to (X2, Y2);    */
	/* X1, Y1, X2, Y2 are pixel coordinates                */
	/* 稢 १ אַ  (X1, Y1)  (X2, Y2); */
	/* X1, Y1, X2, Y2 -  ᥫ न           */

{ int X, Y, T, E, dX, dY, denom, Xinc = 1, Yinc = 1,
  vertlonger = 0, aux;
  checkbreak();      /* To make DOS check for console break    */
		     /* ⠭   ᮫쭮 뢠 */
  if (in_textmode)
	   error       /* "Not in graphics mode (call initgr)" */
		("  ᪮ ० (㦥 맮 initgr)");
  dX = X2 - X1; dY = Y2 - Y1;
  if (dX < 0) {Xinc = -1; dX = -dX;}
  if (dY < 0) {Yinc = -1; dY = -dY;}
  if (dY > dX) { vertlonger = 1; aux = dX; dX = dY; dY = aux; }
  denom = dX << 1;
  T = dY << 1;
  E = -dX; X = X1;
  Y = Y1;
  while (dX-- >= 0)
  { dot(X, Y);
    if ((E += T) > 0)
    { if (vertlonger) X += Xinc; else Y += Yinc;
      E -= denom;
    }
    if (vertlonger) Y += Yinc; else X += Xinc;
  }
}

checkbreak()
{ char ch;
  if (kbhit()) { ch = getch(); kbhit(); ungetch(ch); }
}

dot(X, Y) int X, Y;   /* Light the pixel with coordinates X, Y */
		      /* ᢥ⪠ ᥫ  न⠬ X, Y */
{ int offset;
  char ch;
  offset= 0x2000*(Y&c1) + c2*(Y>>c3) + (X>>3);
  peek(0xB800, offset, &ch, 1);
  ch |= 0x80 >> (X&7);
  poke(0xB800, offset, &ch, 1);
}

int iscolor()                /* Find out which adapter is used */
		    /* । ⨯ ᯮ㥬  */
{ char ch0, ch1, x;
  int86(0x11, &regs, &regs);
  if ((regs.x.ax & 0x30) != 0x30)
         return 1;                           /* Color graphics */
				/* ⭮ ᪨  */
  outp(0x3BF, 3);     /* Configuration switch, see Section 2.6 */
		 /* ४⥫ 䨣樨, . ࠧ 2.6 */
  peek(0xB800, 0, &ch0, 1);
			 /* Try to read ch0 from screen memory */
		   /* ⪠  ch0  ࠭  */
  ch1 = ch0 ^ 0xFF;   /*    Find some value different from ch0 */
	     /* । ண ᫠, ⫨筮  ch0 */
  poke(0xB800, 0, &ch1, 1);
		      /* Try to write this into screen memory  */
	       /* ⪠   ᫮  ࠭  */
  peek(0xB800, 0, &x, 1);      /* Try to read the latter value */
		   /* ⪠   ᫥ 祭 */
  poke(0xB800, 0, &ch0, 1);       /* Restore the old value ch0 */
			/* ⠭ ண 祭 ch0 */
  return ( x == ch1 ? 0 : -1); /* Has written value been read? */
			/* 뫮  ⠭ ᠭ ᫮? */
}

fatal()
       /* Draw a diagonal, then wait until  a key  is pressed, */
       /* and  finally revert to text mode.                    */
       /* 稢    ࠭, ⥬  */
       /*      ⥫쭮  室 */
       /*  ⥪⮢ ०.                                   */
{ draw_line(0, Y__max,  X__max, 0); endgr();
}

check(X, Y) int X, Y;

    /* If point (X, Y)  lies  outside  the screen  boundaries, */
    /* then call fatal,  print the wrong coordinates, and stop */
    /* ᫨ 窠 (X, Y)    । ࠭,   맮 */
    /* 㭪樨 fatal, ⮡ࠦ  न  ⠭ */

{ if (X < 0 || X > X__max || Y < 0 || Y > Y__max)
  { fatal();
    printf
      /* "Point outside screen (X and Y are pixel coordinates" */
	("窠  ࠭ (X  Y  ᥫ न):\n");
    printf("X = %d       Y = %d\n", X, Y);
    printf("x = %10.3f   y = %10.3f\n",
    X/horfact, (Y__max-Y)/vertfact);
    exit(1);
  }
}

int brfun()
    /* Graphics interrupt handler, dealing with console break  */
    /* ࠡ⪠ ᮫쭮 뢠  ᪮ ०   */
{ to_text(); exit(1);     /* Before exit, return to text mode! */
		  /* । 室   ⥪⮢ ० ! */
}
